import gtk

rect_x = 300
rect_y = 220
rect_size = 80

x_offset_to_rect = 0
y_offset_to_rect = 0

dragging = False

draw_area = None

def constrain_to_viewport ():
    global rect_x, rect_y, draw_area

    if rect_x < 0:
        rect_x = 0
    elif rect_x + rect_size >= draw_area.allocation.width:
        rect_x = draw_area.allocation.width - rect_size

    if rect_y < 0:
        rect_y = 0
    elif rect_y + rect_size >= draw_area.allocation.height:
        rect_y = draw_area.allocation.height - rect_size

def expose_event_cb (widget, event):
    cr = widget.window.cairo_create ()
    cr.set_source_rgb (1, 1, 1)

    cr.rectangle (0, 0, widget.allocation.width, widget.allocation.height)
    cr.fill ()

    cr.set_source_rgb (1, 0, 0)
    cr.rectangle (rect_x, rect_y, rect_size, rect_size)
    cr.fill ()

    return False

def button_press_event_cb (widget, event):
    global dragging, draw_area, rect_x, rect_y, x_offset_to_rect, y_offset_to_rect

    if (dragging or event.button != 1
        or event.x < rect_x or event.x >= rect_x + rect_size
        or event.y < rect_y or event.y >= rect_y + rect_size):
        return True

    dragging = True
    x_offset_to_rect = event.x - rect_x
    y_offset_to_rect = event.y - rect_y

    return True

def button_release_event_cb (widget, event):
    global dragging, draw_area, rect_x, rect_y, x_offset_to_rect, y_offset_to_rect

    if not dragging:
        return True

    if event.button != 1:
        return True

    dragging = False
    return True

def motion_notify_event_cb (widget, event):
    global dragging, draw_area, rect_x, rect_y, x_offset_to_rect, y_offset_to_rect

    if not dragging:
        return True

    rect_x = event.x - x_offset_to_rect
    rect_y = event.y - y_offset_to_rect
    constrain_to_viewport ()

    draw_area.queue_draw ()

    return True

window = gtk.Window (gtk.WINDOW_TOPLEVEL)

draw_area = gtk.DrawingArea ()
draw_area.set_size_request (640, 480)
draw_area.add_events (gtk.gdk.BUTTON_PRESS_MASK | gtk.gdk.BUTTON_RELEASE_MASK | gtk.gdk.POINTER_MOTION_MASK)
draw_area.connect ("expose-event", expose_event_cb)
draw_area.connect ("button-press-event", button_press_event_cb)
draw_area.connect ("button-release-event", button_release_event_cb)
draw_area.connect ("motion-notify-event", motion_notify_event_cb)

window.add (draw_area)

window.show_all ()

gtk.main ()
